#!/usr/bin/env python

import os
import urllib

from dm.common.utility.encoder import Encoder
from dm.common.exceptions.dmException import DmException
from dm.common.objects.fileMetadata import FileMetadata
from dsRestApi import DsRestApi

class FileRestApi(DsRestApi):
    
    def __init__(self, username=None, password=None, host=None, port=None, protocol=None):
        DsRestApi.__init__(self, username, password, host, port, protocol)

    @DsRestApi.execute
    def processFile(self, fileName, filePath, experimentName):
        url = '%s/files/processFile' % (self.getContextRoot())
        if not fileName:
            raise InvalidRequest('File name must be provided.')
        url += '?fileName=%s' % Encoder.encode(fileName)
        if not filePath:
            raise InvalidRequest('File path must be provided.')
        url += '&filePath=%s' % Encoder.encode(filePath)
        if not experimentName:
            raise InvalidRequest('Experiment name must be provided.')
        url += '&experimentName=%s' % Encoder.encode(experimentName)
        responseDict = self.sendSessionRequest(url=url, method='POST')
        return FileMetadata(responseDict)

#######################################################################
# Testing.

if __name__ == '__main__':
    api = FileRestApi('sveseli', 'sveseli', 'zagreb.svdev.net', 22236, 'http')
    print api.processFile('file1', '/ESAF/exp1', 'exp1')

